<?php


namespace bhofstaetter\YamlImages;

use SilverStripe\Core\Config\Configurable;
use SilverStripe\Core\Path;
use Symfony\Component\Yaml\Yaml;

class AutoConfig
{
    use Configurable;

    public function build($path = null, $theme = null): void
    {
        if (!$path) {
            $path = Path::join(BASE_PATH, 'app', '_config');
        }

        $name = $theme
            ? 'theme-' . $theme . '-imagesizes-generated'
            : 'app-imagesizes-generated';

        $beforeAfterRule = $theme
            ? "After: 'app/*'\nBefore: '" . str_replace('-generated', '', $name) . "'\n"
            : "Before: '" . str_replace('-generated', '', $name) . "'\n";

        $configArray = $this->createConfigArray();

        if (!$configArray) {
            return;
        }

        $yaml = Yaml::dump($configArray, 99, 2, Yaml::DUMP_EMPTY_ARRAY_AS_SEQUENCE);

        $header = "#\n";
        $header .= "# DO NOT EDIT THIS FILE!\n";
        $header .= "# IT WILL BE AUTOMATICALLY REGENERATED ON dev/build\n";
        $header .= "#\n";
        $header .= "---\nName: $name\n" . $beforeAfterRule . "---\n";

        file_put_contents(Path::join($path, 'imagesizes-generated.yml'), $header . $yaml);
    }

    private function createConfigArray(): array|false
    {
        $config = self::config();
        $gridSettings = $config->get('grid_settings');

        // todo: updatable conditions
        if (
            !isset($gridSettings['columns_count'])
            || !isset($gridSettings['column_width'])
            || !isset($gridSettings['gutter_width'])
            || !isset($gridSettings['max_width_on_breakpoint']['desktop'])
            || !isset($gridSettings['max_width_on_breakpoint']['laptop'])
            || !isset($gridSettings['max_width_on_breakpoint']['tablet'])
            || !isset($gridSettings['max_width_on_breakpoint']['tablet_small'])
            || !isset($gridSettings['max_width_on_breakpoint']['mobile'])
        ) {
            return false;
        }

        $columnsCount = $gridSettings['columns_count'];
        $columnWidth = $gridSettings['column_width'];
        $gutterWidth = $gridSettings['gutter_width'];

        $maxWidthFactors = [];
        $maxWidth = $columnsCount * $columnWidth + ($columnsCount - 1) * $gutterWidth;

        foreach ($gridSettings['max_width_on_breakpoint'] as $bpName => $bpWidth) {
            $maxWidthFactors[$bpName] = $bpWidth * 100 / $maxWidth / 100;
        }

        $generatedYamlConfig = [];

        if ($excludeFromPrefix = $config->get('exclude_from_prefix')) {
            $generatedYamlConfig['exclude_from_prefix'] = $excludeFromPrefix;
        }

        $configs = \SilverStripe\Core\Config\Config::inst()->get(self::class);

        unset(
            $configs['grid_settings'],
            $configs['exclude_from_prefix']
        );

        foreach ($configs as $configName => $configOptions) {
            $forBreakpoint = (isset($configOptions['forBreakpoint']) && isset($maxWidthFactors[$configOptions['forBreakpoint']]))
                ? $configOptions['forBreakpoint']
                : false;

            $manipulations = ImageExtension::get_manipulations($configOptions);
            unset($manipulations['forBreakpoint']);

            foreach ($manipulations as $manipulation => $options) {
                $generatedArguments = [];

                if (isset($options['columns'])) {
                    $width = $options['columns'] * $columnWidth + ($options['columns'] - 1) * $gutterWidth;

                    if ($forBreakpoint) {
                        $width = $width * $maxWidthFactors[$forBreakpoint];
                    }

                    if (isset($manipulations['correction'])) {
                        $width = $width + $width * ($manipulations['correction'] / 100);
                    }

                    $generatedArguments[] = round($width);

                    if (isset($options['ratio'])) {
                        $ratioParts = explode(':', $options['ratio']);

                        if (count($ratioParts) == 2) {
                            $ratio = $ratioParts[0] / $ratioParts[1];
                            $generatedArguments[] = round($width / $ratio);
                        }
                    }
                }

                if (isset($options['arguments'])) {
                    $generatedArguments[] = $options['arguments'];
                }

                if (count($generatedArguments)) {
                    $generatedYamlConfig[$configName][$manipulation] = implode(',', $generatedArguments);
                } else if (is_string($options)) {
                    $generatedYamlConfig[$configName][$manipulation] = $options;
                }
            }

            if (isset($configOptions['breakpoints'])) {
                $generatedYamlConfig[$configName]['breakpoints'] = $configOptions['breakpoints'];
            }
        }

        return [
            Config::class => $generatedYamlConfig,
        ];
    }
}
